=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2007-06-25 01:03:30 +0000
+++ loggerhead/history.py	2007-06-25 01:05:51 +0000
@@ -801,20 +801,20 @@
                 new_lineno = lines[1]
             elif line.startswith(' '):
                 chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=new_lineno,
-                                                 type='context', line=util.html_clean(line[1:])))
+                                                 type='context', line=util.fixed_width(line[1:])))
                 old_lineno += 1
                 new_lineno += 1
             elif line.startswith('+'):
                 chunk.diff.append(util.Container(old_lineno=None, new_lineno=new_lineno,
-                                                 type='insert', line=util.html_clean(line[1:])))
+                                                 type='insert', line=util.fixed_width(line[1:])))
                 new_lineno += 1
             elif line.startswith('-'):
                 chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=None,
-                                                 type='delete', line=util.html_clean(line[1:])))
+                                                 type='delete', line=util.fixed_width(line[1:])))
                 old_lineno += 1
             else:
                 chunk.diff.append(util.Container(old_lineno=None, new_lineno=None,
-                                                 type='unknown', line=util.html_clean(repr(line))))
+                                                 type='unknown', line=util.fixed_width(repr(line))))
         if chunk is not None:
             chunks.append(chunk)
         return chunks

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2007-01-24 19:26:50 +0000
+++ loggerhead/templates/revision.kid	2007-06-25 01:05:51 +0000
@@ -165,19 +165,19 @@
                 <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
                     <span py:if="line.old_lineno" py:strip="True">
                         <td class="lineno">${line.old_lineno}</td>
-                        <td class="diff-${line.old_type}">${XML(line.old_line)}</td>
+                        <td class="diff-${line.old_type}">${line.old_line}</td>
                     </span>
                     <span py:if="not line.old_lineno" py:strip="True">
                         <td class="lineno-skip">${line.old_lineno}</td>
-                        <td class="diff-${line.old_type}-skip">${XML(line.old_line)}</td>
+                        <td class="diff-${line.old_type}-skip">${line.old_line}</td>
                     </span>
                     <span py:if="line.new_lineno" py:strip="True">
                         <td py:if="line.new_lineno" class="lineno">${line.new_lineno}</td>
-                        <td class="diff-${line.new_type}">${XML(line.new_line)}</td>
+                        <td class="diff-${line.new_type}">${line.new_line}</td>
                     </span>
                     <span py:if="not line.new_lineno" py:strip="True">
                         <td py:if="not line.new_lineno" class="lineno-skip">${line.new_lineno}</td>
-                        <td class="diff-${line.new_type}-skip">${XML(line.new_line)}</td>
+                        <td class="diff-${line.new_type}-skip">${line.new_line}</td>
                     </span>
                 </tr>
                 <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
@@ -199,7 +199,7 @@
 	            <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
 	                <td class="lineno">${line.old_lineno}</td>
 	                <td class="lineno">${line.new_lineno}</td>
-	                <td class="diff-${line.type} text">${XML(line.line)}</td>
+	                <td class="diff-${line.type} text">${line.line}</td>
 	                <td> </td>
 	            </tr>
 	            <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2007-03-12 17:51:19 +0000
+++ loggerhead/util.py	2007-06-25 01:05:51 +0000
@@ -181,6 +181,7 @@
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
 
+# FIXME: get rid of this method; use fixed_width() and avoid XML().
 def html_clean(s):
     """
     clean up a string for html display.  expand any tabs, encode any html
@@ -188,11 +189,18 @@
     in displaying monospace text.
     """
     s = cgi.escape(s.expandtabs())
-#    s = _BADCHARS_RE.sub(lambda x: '&#%d;' % (ord(x.group(0)),), s)
     s = s.replace(' ', '&nbsp;')
     return s
 
 
+def fixed_width(s):
+    """
+    expand tabs and turn spaces into "non-breaking spaces", so browsers won't
+    chop up the string.
+    """
+    return s.expandtabs().replace(' ', '\xc2\xa0')
+
+
 def fake_permissions(kind, executable):
     # fake up unix-style permissions given only a "kind" and executable bit
     if kind == 'directory':

